# Program for swap on pancake

This is a program for swap usdt/klko on pancake.

## How to use it?

#### 1. install golang v1.24 and make

```shell
wget https://go.dev/dl/go1.24.1.linux-amd64.tar.gz
tar zxf go1.24.1.linux-amd64.tar.gz -C /usr/local
export PATH=$PATH:/usr/local/go/bin
export GOPATH=$HOME/go
export PATH=$PATH:$GOPATH/bin
sudo apt install make
```


#### 2. clone the code and build the program
```shell
git clone  https://code.wuban.net.cn/luxueqian/pancakeswaper
cd pancakeswaper
make
```

#### 2. fill in the `accounts.csv` file with the accounts you want to do swap for.
The example of the `accounts.csv` file is as follow:
```csv
useraddress, privatekey, recipient
0xeFbb75e446Ec2d8493B3d4d91aC3118953f69b55, 0x1111111111111111, 0xc437593d9C296bf9A5002522A86dad8a4d4Af808
```

#### 4. change configure
There is a `config.yml`, you can change the configure in it.
```yaml
param:
  # routine count.
  routine: 10
  # swap volume for each transaction, unit is 0.1 usdt. example: 1 is 0.1 usdt.
  volume: 1
  # count of transactions per user.
  count: 1
  # gas_price unit is Gwei.
  gas_price: 1
  # slippage, unit is 1/1000. example: 20 means 2.0%.
  slippage: 20
  # tx deadline, unit is minutes, set 0 to disable.
  deadline: 20

pair:
  # pair address.
  pair: "0xcB0AE3B8337f0Cc35563e6b9fC357F2298C0D24a"
  # klko token address
  token: "0x215324115417a13879f865Dc5BB651B18A781a59"

rpc:
  env: "bsc"
  pool: 20
  url: "https://bscnode.bitheart.org"
  proxy: "http://127.0.0.1:7890"

log:
  level: "debug"

users: "accounts.csv"
```

#### 5. run the program

After check the configure, you can run the program.
```shell
./swapper
```

#### 6. check result

When the program is running, you can check the progress in the console.

```text
REPORT                  Failed/Total                    Finished/Total 
USER                        0/80                           18/80   
TX                                                         0/0  
0.18 Cost / 0.28 Receive
```

After the program is finished, you can check the result in the console.

```text
all done, no failed user
```

If an error occurs, you can check the error details in `detail.log`, and the accounts that failed will be recorded in the `failed.json` file.

If the issue is with the account format, please verify that the account format in the `accounts.json` file is correct. After correcting it, rerun the program.

