package pancake

import (
	"code.wuban.net.cn/service/pancakeswapper/types"
	"encoding/hex"
	"github.com/ethereum/go-ethereum/common"
	"github.com/ethereum/go-ethereum/ethclient"
	"math/big"
	"testing"
)

func TestMakeV3SwapExactInPathData(t *testing.T) {
	env := types.GetEnv("bsc")
	data := MakeV3SwapExactInPathData(env)
	t.Log(hex.EncodeToString(data))
}

func TestMakeV3SwapExactInData(t *testing.T) {
	env := types.GetEnv("bsc")
	p := ParamV3SwapExactIn{
		Recipient:    common.HexToAddress("3e3b4d16ce35840c28f90edb7f38e5bdd976c7e3"),
		AmountIn:     big.NewInt(103400000000000),
		AmountOutMin: big.NewInt(13211344443399),
		Path:         nil,
		PayerIsUser:  true,
	}
	data, err := MakeV3SwapExactInData(env, p)
	if err != nil {
		t.Fatal(err)
	}
	t.Log(hex.EncodeToString(data))
}

func TestGetAmountOutMin(t *testing.T) {
	client, _ := ethclient.Dial("https://bscnode.bitheart.org")
	env := types.GetEnv("bsc")
	in := int64(10000)
	out, err := GetAmountOutMin(client, env, big.NewInt(in), 10, big.NewInt(10000))
	if err != nil {
		t.Fatal(err)
	}
	bfOut := new(big.Float).SetInt(out)
	v, _ := bfOut.Float64()
	t.Logf("in:%d, out: %f", in, v/1e18)
}
