package work

import (
	"fmt"
	"math/big"
	"os"
	"sync"
)

var (
	logFile = "detail.log"
	logIns  *os.File
	mux     sync.Mutex
	chainId *big.Int
)

func WorkInit(cid int64) {
	ins, err := os.OpenFile(logFile, os.O_CREATE|os.O_APPEND|os.O_WRONLY, 0666)
	if err != nil {
		panic(fmt.Errorf("can't create log file: %v", err))
	}
	logIns = ins
	chainId = big.NewInt(cid)
}
func WriteLog(s string) {
	mux.Lock()
	defer mux.Unlock()
	// write to file
	logIns.WriteString(s + "\n")
}
func WriteFinished() {
	mux.Lock()
	defer mux.Unlock()
	logIns.Close()
}
